Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_interp.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_interp.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_interp.F90	(revision 14644)
@@ -2,5 +2,5 @@
    !!======================================================================
    !!                   ***  MODULE  agrif_oce_interp  ***
-   !! AGRIF: interpolation package for the ocean dynamics (OPA)
+   !! AGRIF: interpolation package for the ocean dynamics (OCE)
    !!======================================================================
    !! History :  2.0  !  2002-06  (L. Debreu)  Original cade
@@ -109,5 +109,5 @@
       vv(:,:,:,Kbb) = vv(:,:,:,Kbb) * vmask(:,:,:) 
 
-      CALL lbc_lnk_multi( 'agrif_istate_oce', uu(:,:,:  ,Kbb), 'U', -1.0_wp , vv(:,:,:,Kbb), 'V', -1.0_wp )
+      CALL lbc_lnk( 'agrif_istate_oce', uu(:,:,:  ,Kbb), 'U', -1.0_wp , vv(:,:,:,Kbb), 'V', -1.0_wp )
       CALL lbc_lnk( 'agrif_istate_oce', ts(:,:,:,:,Kbb), 'T',  1.0_wp )
 
@@ -863,35 +863,35 @@
                   ! Build vertical grids:
                   N_in = mbkt_parent(ji,jj)
-                  ! Input grid (account for partial cells if any):
-                  DO jk=1,N_in
-                     z_in(jk) = ptab(ji,jj,jk,n2) - ptab(ji,jj,k2,n2)
-                     tabin(jk,1:jpts) = ptab(ji,jj,jk,1:jpts)
-                  END DO
+                  N_out = mbkt(ji,jj)
+                  IF (N_in*N_out > 0) THEN
+                     ! Input grid (account for partial cells if any):
+                     DO jk=1,N_in
+                        z_in(jk) = ptab(ji,jj,jk,n2) - ptab(ji,jj,k2,n2)
+                        tabin(jk,1:jpts) = ptab(ji,jj,jk,1:jpts)
+                     END DO
                   
-                  ! Intermediate grid:
-                  IF ( l_vremap ) THEN
-                     DO jk = 1, N_in
-                        h_in_i(jk) = e3t0_parent(ji,jj,jk) * & 
-                          &       (1._wp + ptab(ji,jj,k2,n2)/(ht0_parent(ji,jj)*ssmask(ji,jj) + 1._wp - ssmask(ji,jj)))
+                     ! Intermediate grid:
+                     IF ( l_vremap ) THEN
+                        DO jk = 1, N_in
+                           h_in_i(jk) = e3t0_parent(ji,jj,jk) * & 
+                             &       (1._wp + ptab(ji,jj,k2,n2)/(ht0_parent(ji,jj)*ssmask(ji,jj) + 1._wp - ssmask(ji,jj)))
+                        END DO
+                        z_in_i(1) = 0.5_wp * h_in_i(1)
+                        DO jk=2,N_in
+                           z_in_i(jk) = z_in_i(jk-1) + 0.5_wp * ( h_in_i(jk) + h_in_i(jk-1) )
+                        END DO
+                        z_in_i(1:N_in) = z_in_i(1:N_in)  - ptab(ji,jj,k2,n2)
+                     ENDIF                              
+
+                     ! Output (Child) grid:
+                     DO jk=1,N_out
+                        h_out(jk) = e3t(ji,jj,jk,Krhs_a)
                      END DO
-                     z_in_i(1) = 0.5_wp * h_in_i(1)
-                     DO jk=2,N_in
-                        z_in_i(jk) = z_in_i(jk-1) + 0.5_wp * ( h_in_i(jk) + h_in_i(jk-1) )
+                     z_out(1) = 0.5_wp * h_out(1)
+                     DO jk=2,N_out
+                        z_out(jk) = z_out(jk-1) + 0.5_wp * ( h_out(jk)+h_out(jk-1) )
                      END DO
-                     z_in_i(1:N_in) = z_in_i(1:N_in)  - ptab(ji,jj,k2,n2)
-                  ENDIF                              
-
-                  ! Output (Child) grid:
-                  N_out = mbkt(ji,jj)
-                  DO jk=1,N_out
-                     h_out(jk) = e3t(ji,jj,jk,Krhs_a)
-                  END DO
-                  z_out(1) = 0.5_wp * h_out(1)
-                  DO jk=2,N_out
-                     z_out(jk) = z_out(jk-1) + 0.5_wp * ( h_out(jk)+h_out(jk-1) )
-                  END DO
-                  IF (.NOT.ln_linssh) z_out(1:N_out) = z_out(1:N_out)  - ssh(ji,jj,Krhs_a)
-
-                  IF (N_in*N_out > 0) THEN
+                     IF (.NOT.ln_linssh) z_out(1:N_out) = z_out(1:N_out)  - ssh(ji,jj,Krhs_a)
+
                      IF( l_ini_child ) THEN
                         CALL remap_linear(tabin(1:N_in,1:jpts),z_in(1:N_in),ts(ji,jj,1:N_out,1:jpts,Krhs_a),              &
@@ -1040,50 +1040,48 @@
                   uu(ji,jj,:,Krhs_a) = 0._wp
                   N_in = mbku_parent(ji,jj)
-                  zhtot = 0._wp
-                  DO jk=1,N_in
-                     !IF (jk==N_in) THEN
-                     !   h_in(jk) = hu0_parent(ji,jj) + ptab(ji,jj,k2,2) - zhtot
-                     !ELSE
-                     !   h_in(jk) = ptab(ji,jj,jk,2)/(e2u(ji,jj)*zrhoy) 
-                     !ENDIF
-                     IF ( l_vremap ) THEN
-                        h_in(jk) = e3u0_parent(ji,jj,jk) 
-                     ELSE
-                        IF (jk==N_in) THEN
-                           h_in(jk) = hu0_parent(ji,jj) + ptab(ji,jj,k2,2) - zhtot
+                  N_out = mbku(ji,jj)
+                  IF (N_in*N_out > 0) THEN
+                     zhtot = 0._wp
+                     DO jk=1,N_in
+                        !IF (jk==N_in) THEN
+                        !   h_in(jk) = hu0_parent(ji,jj) + ptab(ji,jj,k2,2) - zhtot
+                        !ELSE
+                        !   h_in(jk) = ptab(ji,jj,jk,2)/(e2u(ji,jj)*zrhoy) 
+                        !ENDIF
+                        IF ( l_vremap ) THEN
+                           h_in(jk) = e3u0_parent(ji,jj,jk) 
                         ELSE
-                           h_in(jk) = ptab(ji,jj,jk,2)/(e2u(ji,jj)*zrhoy) 
+                           IF (jk==N_in) THEN
+                              h_in(jk) = hu0_parent(ji,jj) + ptab(ji,jj,k2,2) - zhtot
+                           ELSE
+                              h_in(jk) = ptab(ji,jj,jk,2)/(e2u(ji,jj)*zrhoy) 
+                           ENDIF
                         ENDIF
-                     ENDIF
-                     zhtot = zhtot + h_in(jk)
-                     IF( h_in(jk) .GT. 0. ) THEN
-                     tabin(jk) = ptab(ji,jj,jk,1)/(e2u(ji,jj)*zrhoy*h_in(jk))
-                     ELSE
-                     tabin(jk) = 0.
-                     ENDIF
-                 END DO
-                 z_in(1) = 0.5_wp * h_in(1) - zhtot + hu0_parent(ji,jj) 
-                 DO jk=2,N_in
-                    z_in(jk) = z_in(jk-1) + 0.5_wp * (h_in(jk)+h_in(jk-1))
-                 END DO
+                        zhtot = zhtot + h_in(jk)
+                        IF( h_in(jk) .GT. 0. ) THEN
+                           tabin(jk) = ptab(ji,jj,jk,1)/(e2u(ji,jj)*zrhoy*h_in(jk))
+                        ELSE
+                           tabin(jk) = 0.
+                        ENDIF
+                    END DO
+                    z_in(1) = 0.5_wp * h_in(1) - zhtot + hu0_parent(ji,jj) 
+                    DO jk=2,N_in
+                       z_in(jk) = z_in(jk-1) + 0.5_wp * (h_in(jk)+h_in(jk-1))
+                    END DO
                      
-                 N_out = 0
-                 DO jk=1,jpk
-                    IF (umask(ji,jj,jk) == 0) EXIT
-                    N_out = N_out + 1
-                    h_out(N_out) = e3u(ji,jj,jk,Krhs_a)
-                 END DO
-
-                 z_out(1) = 0.5_wp * h_out(1) - SUM(h_out(1:N_out)) + hu_0(ji,jj)
-                 DO jk=2,N_out
-                    z_out(jk) = z_out(jk-1) + 0.5_wp * (h_out(jk-1) + h_out(jk)) 
-                 END DO  
-
-                 IF (N_in*N_out > 0) THEN
-                     IF( l_ini_child ) THEN
-                        CALL remap_linear       (tabin(1:N_in),z_in(1:N_in),uu(ji,jj,1:N_out,Krhs_a),z_out(1:N_out),N_in,N_out,1)
-                     ELSE
-                        CALL reconstructandremap(tabin(1:N_in),h_in(1:N_in),uu(ji,jj,1:N_out,Krhs_a),h_out(1:N_out),N_in,N_out,1)
-                     ENDIF   
+                    DO jk=1, N_out
+                       h_out(jk) = e3u(ji,jj,jk,Krhs_a)
+                    END DO
+
+                    z_out(1) = 0.5_wp * h_out(1) - SUM(h_out(1:N_out)) + hu_0(ji,jj)
+                    DO jk=2,N_out
+                       z_out(jk) = z_out(jk-1) + 0.5_wp * (h_out(jk-1) + h_out(jk)) 
+                    END DO  
+
+                    IF( l_ini_child ) THEN
+                       CALL remap_linear       (tabin(1:N_in),z_in(1:N_in),uu(ji,jj,1:N_out,Krhs_a),z_out(1:N_out),N_in,N_out,1)
+                    ELSE
+                       CALL reconstructandremap(tabin(1:N_in),h_in(1:N_in),uu(ji,jj,1:N_out,Krhs_a),h_out(1:N_out),N_in,N_out,1)
+                    ENDIF   
                  ENDIF
                END DO
@@ -1171,46 +1169,45 @@
                   vv(ji,jj,:,Krhs_a) = 0._wp
                   N_in = mbkv_parent(ji,jj)
-                  zhtot = 0._wp
-                  DO jk=1,N_in
-                     !IF (jk==N_in) THEN
-                     !   h_in(jk) = hv0_parent(ji,jj) + ptab(ji,jj,k2,2) - zhtot
-                     !ELSE
-                     !   h_in(jk) = ptab(ji,jj,jk,2)/(e1v(ji,jj)*zrhox) 
-                     !ENDIF
-                     IF (l_vremap) THEN
-                        h_in(jk) = e3v0_parent(ji,jj,jk)
-                     ELSE
-                        IF (jk==N_in) THEN
-                           h_in(jk) = hv0_parent(ji,jj) + ptab(ji,jj,k2,2) - zhtot
+                  N_out = mbkv(ji,jj)
+
+                  IF (N_in*N_out > 0) THEN
+                     zhtot = 0._wp
+                     DO jk=1,N_in
+                        !IF (jk==N_in) THEN
+                        !   h_in(jk) = hv0_parent(ji,jj) + ptab(ji,jj,k2,2) - zhtot
+                        !ELSE
+                        !   h_in(jk) = ptab(ji,jj,jk,2)/(e1v(ji,jj)*zrhox) 
+                        !ENDIF
+                        IF (l_vremap) THEN
+                           h_in(jk) = e3v0_parent(ji,jj,jk)
                         ELSE
-                           h_in(jk) = ptab(ji,jj,jk,2)/(e1v(ji,jj)*zrhox) 
+                           IF (jk==N_in) THEN
+                              h_in(jk) = hv0_parent(ji,jj) + ptab(ji,jj,k2,2) - zhtot
+                           ELSE
+                              h_in(jk) = ptab(ji,jj,jk,2)/(e1v(ji,jj)*zrhox) 
+                           ENDIF
                         ENDIF
-                     ENDIF
-                     zhtot = zhtot + h_in(jk)
-                     IF( h_in(jk) .GT. 0. ) THEN
-                       tabin(jk) = ptab(ji,jj,jk,1)/(e1v(ji,jj)*zrhox*h_in(jk))
-                     ELSE
-                       tabin(jk)  = 0.
-                     ENDIF 
-                  END DO
-
-                  z_in(1) = 0.5_wp * h_in(1) - zhtot + hv0_parent(ji,jj)
-                  DO jk=2,N_in
-                     z_in(jk) = z_in(jk-1) + 0.5_wp * (h_in(jk-1)+h_in(jk))
-                  END DO
-
-                  N_out = 0
-                  DO jk=1,jpk
-                     IF (vmask(ji,jj,jk) == 0) EXIT
-                     N_out = N_out + 1
-                     h_out(N_out) = e3v(ji,jj,jk,Krhs_a)
-                  END DO
-
-                  z_out(1) = 0.5_wp * h_out(1) - SUM(h_out(1:N_out)) + hv_0(ji,jj)
-                  DO jk=2,N_out
-                     z_out(jk) = z_out(jk-1) + 0.5_wp * (h_out(jk-1)+h_out(jk))
-                  END DO
+                        zhtot = zhtot + h_in(jk)
+                        IF( h_in(jk) .GT. 0. ) THEN
+                          tabin(jk) = ptab(ji,jj,jk,1)/(e1v(ji,jj)*zrhox*h_in(jk))
+                        ELSE
+                          tabin(jk)  = 0.
+                        ENDIF 
+                     END DO
+
+                     z_in(1) = 0.5_wp * h_in(1) - zhtot + hv0_parent(ji,jj)
+                     DO jk=2,N_in
+                        z_in(jk) = z_in(jk-1) + 0.5_wp * (h_in(jk-1)+h_in(jk))
+                     END DO
+
+                     DO jk=1,N_out
+                        h_out(jk) = e3v(ji,jj,jk,Krhs_a)
+                     END DO
+
+                     z_out(1) = 0.5_wp * h_out(1) - SUM(h_out(1:N_out)) + hv_0(ji,jj)
+                     DO jk=2,N_out
+                        z_out(jk) = z_out(jk-1) + 0.5_wp * (h_out(jk-1)+h_out(jk))
+                     END DO
  
-                  IF (N_in*N_out > 0) THEN
                      IF( l_ini_child ) THEN
                         CALL remap_linear       (tabin(1:N_in),z_in(1:N_in),vv(ji,jj,1:N_out,Krhs_a),z_out(1:N_out),N_in,N_out,1)
@@ -1560,5 +1557,5 @@
                      &                 ptab(ji,jj,jk), tmask(ji,jj,jk) * e3t_0(ji,jj,jk), &
                      &                 mig0(ji), mjg0(jj), jk
-                !     kindic_agr = kindic_agr + 1
+                     kindic_agr = kindic_agr + 1
                   ENDIF
                END DO
@@ -1703,24 +1700,13 @@
 
          IF( l_vremap ) THEN
-            ! Interpolate thicknesses
+            ! Interpolate interfaces 
             ! Warning: these are masked, hence extrapolated prior interpolation.
             DO jk=k1,k2
                DO jj=j1,j2
                   DO ji=i1,i2
-                      ptab(ji,jj,jk,2) = tmask(ji,jj,jk) * e3t(ji,jj,jk,Kmm_a)
+                      ptab(ji,jj,jk,2) = tmask(ji,jj,jk) * gdepw(ji,jj,jk,Kmm_a)
                   END DO
                END DO
             END DO
-
-            ! Extrapolate thicknesses in partial bottom cells:
-            ! Set them to Agrif_SpecialValue (0.). Correct bottom thicknesses are retrieved later on
-            IF (ln_zps) THEN
-               DO jj=j1,j2
-                  DO ji=i1,i2
-                      jk = mbkt(ji,jj)
-                      ptab(ji,jj,jk,2) = 0._wp
-                  END DO
-               END DO           
-            END IF
         
            ! Save ssh at last level:
@@ -1736,20 +1722,20 @@
          IF( l_vremap ) THEN
             IF (ln_linssh) ptab(i1:i2,j1:j2,k2,2) = 0._wp 
-            avm_k(i1:i2,j1:j2,k1:k2) = 0._wp
+            avm_k(i1:i2,j1:j2,1:jpkm1) = 0._wp
                
             DO jj = j1, j2
                DO ji =i1, i2
                   N_in = mbkt_parent(ji,jj)
-                  IF ( tmask(ji,jj,1) == 0._wp) N_in = 0
-                  z_in(N_in+1) = ht0_parent(ji,jj) + ptab(ji,jj,k2,2)
-                  DO jk = N_in, 1, -1  ! Parent vertical grid               
-                        z_in(jk) = z_in(jk+1) - ptab(ji,jj,jk,2)
-                       tabin(jk) = ptab(ji,jj,jk,1)
-                  END DO
-                  N_out = mbkt(ji,jj) 
-                  DO jk = 1, N_out        ! Child vertical grid
-                     z_out(jk) = gdepw(ji,jj,jk,Kmm_a)
-                  END DO
+                  N_out = mbkt(ji,jj)
                   IF (N_in*N_out > 0) THEN
+                     DO jk = 1, N_in  ! Parent vertical grid               
+                        z_in(jk)  = ptab(ji,jj,jk,2) - ptab(ji,jj,k2,2)
+                        tabin(jk) = ptab(ji,jj,jk,1)
+                     END DO
+                     DO jk = 1, N_out        ! Child vertical grid
+                        z_out(jk) = gdepw(ji,jj,jk,Kmm_a) - ssh(ji,jj,Kmm_a)
+                     END DO
+                     IF (.NOT.ln_linssh) z_out(1:N_out) = z_out(1:N_out)  - ssh(ji,jj,Kmm_a)
+
                      CALL remap_linear(tabin(1:N_in),z_in(1:N_in),avm_k(ji,jj,1:N_out),z_out(1:N_out),N_in,N_out,1)
                   ENDIF
@@ -1757,5 +1743,5 @@
             END DO
          ELSE
-            avm_k(i1:i2,j1:j2,k1:k2) = ptab (i1:i2,j1:j2,k1:k2,1)
+            avm_k(i1:i2,j1:j2,1:jpkm1) = ptab (i1:i2,j1:j2,1:jpkm1,1)
          ENDIF
       ENDIF
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_sponge.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_sponge.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_sponge.F90	(revision 14644)
@@ -4,5 +4,5 @@
    !!======================================================================
    !!                   ***  MODULE  agrif_oce_interp  ***
-   !! AGRIF: sponge package for the ocean dynamics (OPA)
+   !! AGRIF: sponge package for the ocean dynamics (OCE)
    !!======================================================================
    !! History :  2.0  !  2002-06  (XXX)  Original cade
@@ -236,5 +236,5 @@
       END_2D
       
-      CALL lbc_lnk_multi( 'agrif_Sponge', fspu, 'U', 1._wp, fspv, 'V', 1._wp, fspt, 'T', 1._wp, fspf, 'F', 1._wp )
+      CALL lbc_lnk( 'agrif_Sponge', fspu, 'U', 1._wp, fspv, 'V', 1._wp, fspt, 'T', 1._wp, fspf, 'F', 1._wp )
       !
       ! Remove vertical interpolation where not needed:
@@ -368,5 +368,5 @@
          fspf_2d(ji,jj) = ztabramp(ji,jj) * ssvmask(ji,jj) * ssvmask(ji,jj+1)
          END_2D
-      CALL lbc_lnk_multi( 'agrif_Sponge_2d', fspu_2d, 'U', 1._wp, fspv_2d, 'V', 1._wp, fspt_2d, 'T', 1._wp, fspf_2d, 'F', 1._wp )
+      CALL lbc_lnk( 'agrif_Sponge_2d', fspu_2d, 'U', 1._wp, fspv_2d, 'V', 1._wp, fspt_2d, 'T', 1._wp, fspf_2d, 'F', 1._wp )
       !
 #endif
@@ -658,31 +658,29 @@
                   tabres_child(ji,jj,:) = 0._wp
                   N_in = mbku_parent(ji,jj)
-                  zhtot = 0._wp
-                  DO jk=1,N_in
-                     !IF (jk==N_in) THEN
-                     !   h_in(jk) = hu0_parent(ji,jj) + tabres(ji,jj,k2,m2) - zhtot
-                     !ELSE
-                     !   h_in(jk) = tabres(ji,jj,jk,m2)
-                     !ENDIF
-                     h_in(jk) = e3u0_parent(ji,jj,jk)
-                     zhtot = zhtot + h_in(jk)
-                     tabin(jk) = tabres(ji,jj,jk,m1)
-                  END DO
-                  !         
-                  N_out = 0
-                  DO jk=1,jpk
-                     IF (umask(ji,jj,jk) == 0) EXIT
-                     N_out = N_out + 1
-                     h_out(N_out) = e3u(ji,jj,jk,Kbb_a)
-                  END DO
-
-                  ! Account for small differences in free-surface
-                  IF ( sum(h_out(1:N_out)) > sum(h_in(1:N_in) )) THEN
-                     h_out(1) = h_out(1) - ( sum(h_out(1:N_out))-sum(h_in(1:N_in)) )
-                  ELSE
-                     h_in(1)   = h_in(1)   - (sum(h_in(1:N_in))-sum(h_out(1:N_out)) )
-                  ENDIF
+                  N_out = mbku(ji,jj)
+                  IF (N_in * N_out > 0) THEN
+                     zhtot = 0._wp
+                     DO jk=1,N_in
+                        !IF (jk==N_in) THEN
+                        !   h_in(jk) = hu0_parent(ji,jj) + tabres(ji,jj,k2,m2) - zhtot
+                        !ELSE
+                        !   h_in(jk) = tabres(ji,jj,jk,m2)
+                        !ENDIF
+                        h_in(jk) = e3u0_parent(ji,jj,jk)
+                        zhtot = zhtot + h_in(jk)
+                        tabin(jk) = tabres(ji,jj,jk,m1)
+                     END DO
+                     !         
+                     DO jk=1,N_out
+                        h_out(jk) = e3u(ji,jj,jk,Kbb_a)
+                     END DO
+
+                     ! Account for small differences in free-surface
+                     IF ( sum(h_out(1:N_out)) > sum(h_in(1:N_in) )) THEN
+                        h_out(1) = h_out(1) - ( sum(h_out(1:N_out))-sum(h_in(1:N_in)) )
+                     ELSE
+                        h_in(1)   = h_in(1)   - (sum(h_in(1:N_in))-sum(h_out(1:N_out)) )
+                     ENDIF
                   
-                  IF (N_in * N_out > 0) THEN
                      CALL reconstructandremap(tabin(1:N_in),h_in(1:N_in),tabres_child(ji,jj,1:N_out),h_out(1:N_out),N_in,N_out,1)
                   ENDIF 
@@ -843,32 +841,31 @@
                   tabres_child(ji,jj,:) = 0._wp
                   N_in = mbkv_parent(ji,jj)
-                  zhtot = 0._wp
-                  DO jk=1,N_in
-                     !IF (jk==N_in) THEN
-                     !   h_in(jk) = hv0_parent(ji,jj) + tabres(ji,jj,k2,m2) - zhtot
-                     !ELSE
-                     !   h_in(jk) = tabres(ji,jj,jk,m2)
-                     !ENDIF
-                     h_in(jk) = e3v0_parent(ji,jj,jk)
-                     zhtot = zhtot + h_in(jk)
-                     tabin(jk) = tabres(ji,jj,jk,m1)
-                  END DO
-                  !          
-                  N_out = 0
-                  DO jk=1,jpk
-                     IF (vmask(ji,jj,jk) == 0) EXIT
-                     N_out = N_out + 1
-                     h_out(N_out) = e3v(ji,jj,jk,Kbb_a)
-                  END DO
-
-                  ! Account for small differences in free-surface
-                  IF ( sum(h_out(1:N_out)) > sum(h_in(1:N_in) )) THEN
-                     h_out(1) = h_out(1) - ( sum(h_out(1:N_out))-sum(h_in(1:N_in)) )
-                  ELSE
-                     h_in(1)   = h_in(1) - (  sum(h_in(1:N_in))-sum(h_out(1:N_out)) )
-                  ENDIF
+                  N_out = mbkv(ji,jj)
+                  IF (N_in * N_out > 0) THEN
+                     zhtot = 0._wp
+                     DO jk=1,N_in
+                        !IF (jk==N_in) THEN
+                        !   h_in(jk) = hv0_parent(ji,jj) + tabres(ji,jj,k2,m2) - zhtot
+                        !ELSE
+                        !   h_in(jk) = tabres(ji,jj,jk,m2)
+                        !ENDIF
+                        h_in(jk) = e3v0_parent(ji,jj,jk)
+                        zhtot = zhtot + h_in(jk)
+                        tabin(jk) = tabres(ji,jj,jk,m1)
+                     END DO
+                     !          
+                     DO jk=1,N_out
+                        h_out(jk) = e3v(ji,jj,jk,Kbb_a)
+                     END DO
+
+                     ! Account for small differences in free-surface
+                     IF ( sum(h_out(1:N_out)) > sum(h_in(1:N_in) )) THEN
+                        h_out(1) = h_out(1) - ( sum(h_out(1:N_out))-sum(h_in(1:N_in)) )
+                     ELSE
+                        h_in(1)   = h_in(1) - (  sum(h_in(1:N_in))-sum(h_out(1:N_out)) )
+                     ENDIF
          
-                  IF (N_in * N_out > 0) THEN
                      CALL reconstructandremap(tabin(1:N_in),h_in(1:N_in),tabres_child(ji,jj,1:N_out),h_out(1:N_out),N_in,N_out,1)
+
                   ENDIF
                END DO
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_update.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_update.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_oce_update.F90	(revision 14644)
@@ -6,5 +6,5 @@
    !!======================================================================
    !!                   ***  MODULE  agrif_oce_interp  ***
-   !! AGRIF: update package for the ocean dynamics (OPA)
+   !! AGRIF: update package for the ocean dynamics (OCE)
    !!======================================================================
    !! History :  2.0  !  2002-06  (L. Debreu)  Original code
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_user.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_user.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/agrif_user.F90	(revision 14644)
@@ -63,5 +63,5 @@
 ! In case of East-West periodicity, prevent AGRIF interpolation at east and west boundaries
 ! The procnames will not be called at these boundaries
-      IF (jperio == 1) THEN
+      IF (l_Iperio) THEN
          CALL Agrif_Set_NearCommonBorderX(.TRUE.)
          CALL Agrif_Set_DistantCommonBorderX(.TRUE.)
@@ -209,5 +209,5 @@
       ENDIF
       !
-      CALL lbc_lnk_multi( 'Agrif_Init_Domain', hu0_parent, 'U', 1.0_wp, hv0_parent, 'V', 1.0_wp )
+      CALL lbc_lnk( 'Agrif_Init_Domain', hu0_parent, 'U', 1.0_wp, hv0_parent, 'V', 1.0_wp )
       DO_2D( 0, 0, 0, 0 )
          zk(ji,jj) = REAL( mbku_parent(ji,jj), wp )
@@ -251,5 +251,5 @@
          ENDIF
 
-         CALL lbc_lnk_multi( 'Agrif_Init_Domain', e3u0_parent, 'U', 1.0_wp, e3v0_parent, 'V', 1.0_wp )
+         CALL lbc_lnk( 'Agrif_Init_Domain', e3u0_parent, 'U', 1.0_wp, e3v0_parent, 'V', 1.0_wp )
       ENDIF
 
@@ -272,13 +272,13 @@
                   
             CALL Agrif_check_bat( kindic_agr )           
-
-            CALL mpp_sum( 'agrif_InitValues_Domain', kindic_agr )
-            IF( kindic_agr /= 0 ) THEN
-               CALL ctl_stop('==> Child Bathymetry is NOT correct near boundaries.')
-            ELSE
-               IF(lwp) WRITE(numout,*) '==> Child Bathymetry is ok near boundaries.'
-               IF(lwp) WRITE(numout,*) ' '
-            ENDIF  
          ENDIF
+         !
+         CALL mpp_sum( 'agrif_InitValues_Domain', kindic_agr )
+         IF( kindic_agr /= 0 ) THEN
+            CALL ctl_stop('==> Child Bathymetry is NOT correct near boundaries.')
+         ELSE
+            IF(lwp) WRITE(numout,*) '==> Child Bathymetry is ok near boundaries.'
+            IF(lwp) WRITE(numout,*) ' '
+         ENDIF  
       ENDIF
       !
@@ -532,5 +532,5 @@
       CALL Agrif_Set_bc(   ub2b_cor_id, (/-imaxrho*nn_shift_bar,ind1/) )
       CALL Agrif_Set_bc(   vb2b_cor_id, (/-imaxrho*nn_shift_bar,ind1/) )
-      IF( ln_zdftke.OR.ln_zdfgls ) CALL Agrif_Set_bc( avm_id, (/0,ind1/) )
+      IF( ln_zdftke.OR.ln_zdfgls ) CALL Agrif_Set_bc( avm_id, (/0,ind1-1/) )
 !!$      CALL Agrif_Set_bc(glamt_id, (/0,ind1-1/) )  
 !!$      CALL Agrif_Set_bc(gphit_id, (/0,ind1-1/) )  
@@ -872,5 +872,5 @@
       nbghostcells_y_n = nbghostcells
       !
-      IF(   jperio == 1  )   nbghostcells_x   = 0
+      IF(    l_Iperio    )   nbghostcells_x   = 0
       IF( .NOT. lk_south )   nbghostcells_y_s = 0
       IF( .NOT. lk_north )   nbghostcells_y_n = 0
@@ -889,5 +889,5 @@
 
    
-# if defined key_mpp_mpi
+# if ! defined key_mpi_off
    SUBROUTINE Agrif_InvLoc( indloc, nprocloc, i, indglob )
       !!----------------------------------------------------------------------
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/vremap.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/vremap.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/NST/vremap.F90	(revision 14644)
@@ -1,3 +1,3 @@
-#undef PPR_LIB      /* USE PPR library */
+#define PPR_LIB      /* USE PPR library */
 MODULE vremap
 !$AGRIF_DO_NOT_TREAT
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/BDY/bdydyn2d.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/BDY/bdydyn2d.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/BDY/bdydyn2d.F90	(revision 14644)
@@ -18,4 +18,5 @@
    USE bdylib          ! BDY library routines
    USE phycst          ! physical constants
+   USE lib_mpp, ONLY: jpfillnothing
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE wet_dry         ! Use wet dry to get reference ssh level
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/BDY/bdydyn3d.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/BDY/bdydyn3d.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/BDY/bdydyn3d.F90	(revision 14644)
@@ -15,4 +15,5 @@
    USE bdy_oce         ! ocean open boundary conditions
    USE bdylib          ! for orlanski library routines
+   USE lib_mpp, ONLY: jpfillnothing
    USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
    USE in_out_manager  !
Index: /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/BDY/bdyice.F90
===================================================================
--- /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/BDY/bdyice.F90	(revision 14643)
+++ /NEMO/branches/2020/dev_r14116_HPC-04_mcastril_Mixed_Precision_implementation_final/src/OCE/BDY/bdyice.F90	(revision 14644)
@@ -92,11 +92,11 @@
          IF( ANY(llsend1) .OR. ANY(llrecv1) ) THEN   ! if need to send/recv in at least one direction
             ! exchange 3d arrays
-            CALL lbc_lnk_multi('bdyice', a_i , 'T', 1._wp, h_i , 'T', 1._wp, h_s , 'T', 1._wp, oa_i, 'T', 1._wp                   &
-               &                       , s_i , 'T', 1._wp, t_su, 'T', 1._wp, v_i , 'T', 1._wp, v_s , 'T', 1._wp, sv_i, 'T', 1._wp &
-               &                       , a_ip, 'T', 1._wp, v_ip, 'T', 1._wp, v_il, 'T', 1._wp                                     &
-               &                       , kfillmode=jpfillnothing ,lsend=llsend1, lrecv=llrecv1 )
+            CALL lbc_lnk('bdyice', a_i , 'T', 1._wp, h_i , 'T', 1._wp, h_s , 'T', 1._wp, oa_i, 'T', 1._wp                   &
+               &                 , s_i , 'T', 1._wp, t_su, 'T', 1._wp, v_i , 'T', 1._wp, v_s , 'T', 1._wp, sv_i, 'T', 1._wp &
+               &                 , a_ip, 'T', 1._wp, v_ip, 'T', 1._wp, v_il, 'T', 1._wp                                     &
+               &                 , kfillmode=jpfillnothing ,lsend=llsend1, lrecv=llrecv1 )
             ! exchange 4d arrays :   third dimension = 1   and then   third dimension = jpk
-            CALL lbc_lnk_multi('bdyice', t_s , 'T', 1._wp, e_s , 'T', 1._wp, kfillmode=jpfillnothing ,lsend=llsend1, lrecv=llrecv1 )
-            CALL lbc_lnk_multi('bdyice', t_i , 'T', 1._wp, e_i , 'T', 1._wp, kfillmode=jpfillnothing ,lsend=llsend1, lrecv=llrecv1 )
+            CALL lbc_lnk('bdyice', t_s , 'T', 1._wp, e_s , 'T', 1._wp, kfillmode=jpfillnothing ,lsend=llsend1, lrecv=llrecv1 )
+            CALL lbc_lnk('bdyice', t_i , 'T', 1._wp, e_i , 'T', 1._wp, kfillmode=jpfillnothing ,lsend=llsend1, lrecv=llrecv1 )
          END IF
       END DO   ! ir
